# Allowed MCU types: 90s2313, 90s2323, 90s2333, tiny22, 90s2343,
# 90s4433, 90s4414, 90s4434, 90s8515, 90s8535, mega603, mega103
MCU		= mega103

CFLAGS		= $(OPTIM) -DKHZ=4000
ASFLAGS		= -Wa,-mmcu=at$(MCU) $(CFLAGS) #-DWITH_UNDERSCORES
LDFLAGS		= -nostdlib $(TOPDIR)/lib/gcrt1.o
ARFLAGS		= r
LIBS		= -L$(TOPDIR)/lib -luos -lgcc
CC		= avr-gcc -g -mmcu=at$(MCU) -Wall
AR		= avr-ar
ISP		= uisp -v -dcasc -dserial=/dev/ttyS0 --erase --upload #--verify
DIRS		= arch/$(ARCH)/lib
TESTS		= arch/$(ARCH)/tests

.c.out:
		$(CC) $(LDFLAGS) $(CFLAGS) $< $(LIBS) -o $@
		avr-objdump -D $@ > $*.dis

.o.out:
		$(CC) $(LDFLAGS) $< $(LIBS) -o $@
		avr-objdump -D $@ > $*.dis

.out.srec:
		avr-objcopy -O srec $< $@
		@chmod -x $@

.out.hex:
		avr-objcopy -O ihex $< $@
		@chmod -x $@

.SUFFIXES:	.srec .hex
