#ifdef _ASSERT_H
#undef _ASSERT_H
#undef assert
#endif

#define	_ASSERT_H
#include <sys/lib.h>

/*
 * void assert (int expression);
 *
 * If NDEBUG is defined, do nothing.
 * If not, and EXPRESSION is zero, print an error message and abort.
 */
#ifdef NDEBUG

#define assert(expr)		((void) 0)

#else /* Not NDEBUG */

/* This prints an "Assertion failed" message and aborts. */
void __assert_fail (char *expr, char *file, unsigned int line, char *func)
	__attribute__ ((__noreturn__));

#define assert(expr) ((void) ((expr) ? 0 : __assert_fail (CONST(#expr), \
	CONST(__FILE__), __LINE__, CONST(__PRETTY_FUNCTION__)), 0))

#endif /* NDEBUG */
