#include <sys/lib.h>

int
debug_printf (const char *fmt, ...)
{
	va_list	args;
	int err;

	va_start (args, fmt);
	err = doprnt (debug_putchar, 0, fmt, args);
	va_end (args);
	return err;
}

#ifndef NDEBUG
void
__assert_fail (char *cond, char *file, unsigned int line, char *func)
{
	debug_printf (CONST("Assertion failed in function `%S':\n%S:%u: %S\n"),
		func, file, line, cond);
	for (;;)
		breakpoint ();
}
#endif
