/*
 * Testing NVRAM.
 */
#include "sys/uos.h"
#include "sys/uart.h"
#include "sys/nvram.h"
#include "sys/lib.h"

char task [200];
uart_t uart;
nvram_t nvram;

extern void breakpoint (void);

void test (void *data)
{
	int i;
	unsigned char c;

	uart_printf (&uart, CONST("Test of NVRAM, total %d bytes"), E2END+1);
	for (;;) {
		uart_puts (&uart, CONST("\nWriting: "));
		for (i=0; i<=E2END; ++i) {
			nvram_write (&nvram, i, ~i);
			if ((i & 63) == 63)
				uart_putchar (&uart, '.');
		}
		uart_puts (&uart, CONST("\nReading: "));
		for (i=0; i<=E2END; ++i) {
			c = nvram_read (&nvram, i);
			if (c != (unsigned char) ~i) {
				uart_printf (&uart, CONST("error on byte 0x%x: written 0x%x, read 0x%x\n"),
					i, (unsigned char) ~i, c);
				continue;
			}
			if ((i & 63) == 63)
				uart_putchar (&uart, '.');
		}
	}
}

void uos_init (void)
{
breakpoint();
	uart_init (&uart, 90, 9600);
	nvram_init (&nvram);
	task_create (test, 0, 1, task, sizeof (task), 0);
}
