#include <sys/lib.h>
#include <sys/uos.h>
#include <sys/timer.h>

#ifdef __MSDOS__
#   include <conio.h>
#   define PRINTF(fmt,arg)	cprintf (fmt, arg)
#   define PUTCHAR(sym)		putch (sym)
#endif

#ifdef __AVR__
#   include <sys/uart.h>

#   define LIGHTRED		1
#   define LIGHTGREEN		2
#   define LIGHTBLUE		4

#   define PRINTF(fmt,arg)	uart_printf (&uart, CONST(fmt), arg)
#   define PUTCHAR(sym)		uart_putchar (&uart, sym)

uart_t uart;			/* Console driver */

static inline void textattr (int c)
{
	uart_printf (&uart, CONST("\033[1;3%dm"), c);
}

static inline void gotoxy (int x, int y)
{
	uart_printf (&uart, CONST("\033[%d;%dH"), y, x);
}

static inline void clrscr (void)
{
	uart_printf (&uart, CONST("\033[2J"));
}
#endif
