/*
 * Random letters on the screen.
 */
#include "demo.h"

#ifdef __AVR__
#   define STACKSZ 	300	/* Task stack size */
#endif
#ifdef __MSDOS__
#   define STACKSZ 	400	/* Task stack size */
#endif
#define NTASKS		10	/* Number of identical tasks */

char stat_stack [STACKSZ];
char symbol_stack [NTASKS] [STACKSZ];
lock_t screen;
timer_t timer;

void stat_task (void *arg)
{
/*breakpoint();*/
	lock_acquire (&screen);
	clrscr ();
	for (;;) {
		gotoxy (1, 1);
		textattr (7);

		PRINTF ("msec %ld", timer_milliseconds (&timer));
		PRINTF (", stack avail: timer %d", task_stack_avail (timer.stack));
#ifdef __AVR__
		PRINTF (", uart %d", task_stack_avail (uart.stack));
#endif
		PRINTF (", task stat %d", task_stack_avail (stat_stack));
		PRINTF (", task symbol %d", task_stack_avail (symbol_stack[0]));

		lock_release (&screen);
#ifdef __MSDOS__
		if (kbhit ()) {
			getch() || getch();
			uos_halt ();
		}
#endif
		timer_delay (&timer, 1000);
		lock_acquire (&screen);
	}
}

void symbol_task (void *data)
{
	char sym = (int) data;
	for (;;) {
		/* Display the task number on the screen. */
		int x = 1 + rand15() % 80;
		int y = 2 + rand15() % 24;
		if (x == 80 && y == 25)
			continue;
		lock_acquire (&screen);
		gotoxy (x, y);
		textattr (1 + rand15() % 6);
		PUTCHAR (sym);
		lock_release (&screen);
		timer_delay (&timer, 50);
	}
}

void uos_init ()
{
	int i;

#ifdef __AVR__
breakpoint();
	uart_init (&uart, 90, 9600);
#endif
	timer_init (&timer, 100);

	/* Create the statistics task. */
	task_create (stat_task, 0, 2, stat_stack, STACKSZ, 0);

	/* Create NTASKS identical tasks.
	 * Each task will display its own letter */
	for (i=0; i<NTASKS; ++i)
		task_create (symbol_task, (void*)(i+'a'), 1,
			symbol_stack[i], STACKSZ, 0);
}
