/*
 * Worms - not finished yet.
 */
#include <string.h>
#include <assert.h>
#include "demo.h"

#define STACKSZ 	200	/* Task stack size */
#define NTASKS		5	/* Number of identical tasks */
#define MAXLEN		10	/* Maximum length of worms */

typedef struct {
	int len;
	int speed;
	int color;
	int direction;
	int x [MAXLEN];
	int y [MAXLEN];
	char stack [STACKSZ];
} worm_t;

worm_t worm [NTASKS];
char map [40] [25];
lock_t screen;
timer_t timer;
char initialized;

int busy (int x, int y)
{
	if (x < 1 || y < 1 || x > 40 || y > 25)
		return 1;
	return map [x-1] [y-1];
}

void draw (int x, int y, int sym, int color)
{
	assert (x >= 1 && x <= 40);
	assert (y >= 1 && y <= 25);
	lock_acquire (&screen);
	textattr (color);
	gotoxy (x+x, y);
	PUTCHAR (sym);
	if (sym != '-')
		sym = ' ';
	PUTCHAR (sym);
	lock_release (&screen);
	map [x-1] [y-1] = sym==' ' ? 0 : 1;
}

void revert (int *vector)
{
	int buf [MAXLEN], *p = buf+MAXLEN, i;

	for (i=0; i<MAXLEN && vector[i]; ++i)
		*--p = vector[i];
	assert (i > 0);
	assert (i <= MAXLEN);
	assert (p >= buf);
	memmove (vector, p, i * sizeof (int));
}

void task (void *arg)
{
	worm_t *w = arg;
	int nx, ny;

	if (! initialized) {
		lock_acquire (&screen);
		clrscr ();
		lock_release (&screen);
		initialized = 1;
	}
	draw (w->x[0], w->y[0], (w->direction & 1) ? '-' : '|', w->color);
	for (;;) {
		switch (w->direction) {
		default:
		case 0: nx = w->x[0];     ny = w->y[0] - 1; break; /* north */
		case 1: nx = w->x[0] + 1; ny = w->y[0];     break; /* east */
		case 2: nx = w->x[0];     ny = w->y[0] + 1; break; /* south */
		case 3: nx = w->x[0] - 1; ny = w->y[0];     break; /* west */
		}

		if (busy (nx, ny)) {
			w->direction = (w->direction + 2) % 4;
			revert (w->x);
			revert (w->y);
		} else {
			draw (nx, ny, (w->direction & 1) ? '-' : '|', w->color);
			if (w->x [w->len-1])
				draw (w->x [w->len-1], w->y [w->len-1], ' ', 7);
			assert (w->len > 1);
			assert (w->len <= MAXLEN);
			memmove (w->x+1, w->x, (w->len-1) * sizeof (int));
			memmove (w->y+1, w->y, (w->len-1) * sizeof (int));
			w->x[0] = nx;
			w->y[0] = ny;
		}

		timer_delay (&timer, 55 * w->speed);
#ifdef __MSDOS__
		if (kbhit ()) {
			getch() || getch();
			uos_halt ();
		}
#endif
	}
}

void uos_init ()
{
	worm_t *w;

#ifdef __AVR__
breakpoint();
	uart_init (&uart, 90, 9600);
#endif
	timer_init (&timer, 100);

	/* Create NTASKS worms. */
	for (w=worm; w<worm+NTASKS; ++w) {
		w->len = 3 + rand15() % (MAXLEN-2);
		w->speed = 1 + rand15() % 3;
		w->color = 1 + rand15() % 7;
		w->direction = rand15() % 4;
		w->x[0] = 1 + rand15() % 40;
		w->y[0] = 1 + rand15() % 25;
		task_create (task, w, 1, w->stack, STACKSZ, 0);
	}
}
