#include <stdlib.h>
#include <assert.h>
#include "sys/uos.h"
#include "sys/machdep.h"
#include "sys/internal.h"

/*
 * Create new task.
 */
task_t *
task_create (void (*func)(void*), void *arg, int prio, char *stack,
	int stacksz, lock_t *finalizer)
{
	task_t *t;
	int x;

	t = (task_t*) stack;
	t->prio = prio;
	t->finalizer = finalizer;
	t->lock = 0;
	t->wait = 0;
	t->slaves.head = 0;
	t->slaves.tail = 0;
	memset (t->stack, STACK_MAGIC, stacksz - sizeof(task_t));

	/* Build an interrupt frame on the task stack.
	 * Set instruction pointer to func, argument to arg. */
	MACHDEP_BUILD_STACK_FRAME (t, func, arg, stacksz);
	MACHDEP_INTR_DISABLE (&x);
	task_enqueue (&task_active, t);
	MACHDEP_INTR_RESTORE (x);
	return t;
}
