#include <stdlib.h>
#include <assert.h>
#include "sys/uos.h"
#include "sys/machdep.h"
#include "sys/internal.h"

/*
 * Delete the task, return the given message to waiters.
 */
void
task_delete (task_t *t, void *message)
{
	int x;

	MACHDEP_INTR_DISABLE (&x);
	task_dequeue (&task_active, t);
	if (t->lock) {
		task_dequeue (&t->lock->slaves, t);
		t->lock = 0;
	}
	if (t->wait) {
		task_dequeue (&t->wait->waiters, t);
		t->wait = 0;
	}
	while (t->slaves.head) {
		assert (t == t->slaves.head->master);
		lock_release (t->slaves.head);
	}
	if (t->finalizer)
		lock_signal (t->finalizer, message);
	MACHDEP_INTR_RESTORE (x);
	MACHDEP_TASK_SWITCH ();
}
