/*
 * The internal uOS definitions.
 * Not for the end user.
 */

/* The table of interrupt handlers. */
extern lock_t *uos_handler[];

/* Current running task. */
extern task_t *task_current;

/* List of tasks ready to run. */
extern task_list_t task_active;

/* Compute the most priority task. */
task_t *task_policy (void);

/* Activate all waiters of the lock. */
void lock_activate (lock_t *m, void *message);

/* Utility functions. */
void task_enqueue (task_list_t *list, task_t *elem);
void task_dequeue (task_list_t *list, task_t *elem);
void lock_enqueue (lock_list_t *list, lock_t *elem);
void lock_dequeue (lock_list_t *list, lock_t *elem);

#define STACK_MAGIC		'\xaa'

#ifndef NDEBUG
#define STACK_GUARD(x)		((x)->stack[0] == STACK_MAGIC)
#endif
