#include <stdarg.h>

#ifndef UART_STACKSZ
#define UART_STACKSZ	100		/* enough for AVR */
#endif

typedef struct {
	char stack [UART_STACKSZ];	/* task stack */
	lock_t transmitter;
	lock_t receiver;
	int buffered_char;
} uart_t;

void uart_init (uart_t *u, int prio, unsigned long baud);
void uart_putchar (uart_t *u, char c);
unsigned char uart_getchar (uart_t *u);
void uart_puts (uart_t *u, const char *str);
int uart_vprintf (uart_t *u, const char *fmt, va_list args);
int uart_printf (uart_t *u, const char *fmt, ...);
